function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
import React, { Component } from "react";
import { Form } from "react-bootstrap";
import _ from "lodash";
var PercentWidget = /*#__PURE__*/function (_Component) {
  function PercentWidget(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _this.state = _extends({}, props, {
      value: props.value && props.value * 100
    });
    return _this;
  }
  _inheritsLoose(PercentWidget, _Component);
  var _proto = PercentWidget.prototype;
  _proto._handleChange = function _handleChange(event) {
    var digits = this.state.options.digits == undefined ? 2 : this.state.options.digits;
    var value = event.target.value.replace(/[^0-9.]/g, "");
    if (event.type === "blur" && event.target.value) value = parseFloat(value).toFixed(digits);
    this.setState({
      value: value
    });
    this.state.onChange(value / 100);
  };
  _proto.render = function render() {
    var _this2 = this;
    var _$get = _.get(this.props, "schema", {}),
      title = _$get.title;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Form.Label, null, title), /*#__PURE__*/React.createElement("div", {
      className: "input-group"
    }, /*#__PURE__*/React.createElement("input", {
      type: "text",
      id: this.props.id,
      className: "form-control percent",
      style: {
        textAlign: "right"
      },
      value: this.state.value,
      required: this.state.required,
      onBlur: function onBlur(event) {
        _this2._handleChange(event);
      },
      onChange: function onChange(event) {
        _this2._handleChange(event);
      },
      disabled: this.state.disabled,
      readOnly: this.state.readonly
    }), /*#__PURE__*/React.createElement("div", {
      className: "input-group-append"
    }, /*#__PURE__*/React.createElement("span", {
      className: "input-group-text"
    }, "%"))));
  };
  return PercentWidget;
}(Component);
export default PercentWidget;