"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _lodash = _interopRequireDefault(require("lodash"));
var _reactPlacesAutocomplete = require("react-places-autocomplete");
var _ReactPlaceField = _interopRequireDefault(require("./ReactPlaceField"));
var _reactBootstrap = require("react-bootstrap");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == typeof h && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(typeof e + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function _asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var DEFAULT_FIELDS = {
  address_1: "address_1",
  address_2: "address_2",
  city: "city",
  state: "state",
  postal_code: "postal_code",
  country: "country",
  latitude: "latitude",
  longitude: "longitude"
};
var ReactPlaceAutofillField = /*#__PURE__*/function (_React$Component) {
  function ReactPlaceAutofillField() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _defineProperty(_this, "state", {
      id: Math.floor(Math.random() * 100)
    });
    _defineProperty(_this, "handleFieldChange", function (key, fieldName) {
      return function (event) {
        var propsName = _this.props.name;
        var addressData = _this.props.formData;
        _lodash["default"].set(addressData, fieldName, event.target.value);
        _this.props.onChange && _this.props.onChange(addressData);
        _this.forceUpdate();
      };
    });
    _defineProperty(_this, "handlePlaceSelect", /*#__PURE__*/function () {
      var _ref = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(address) {
        var _addressData;
        var fieldNames, oldFormData, _extends2, newFormData, _yield$geocodeByPlace, geocode, firstAddress, city, state, country, postalCode, _this$getFieldLocatio, lat, lng, addressData, updateAdjacentFields;
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              fieldNames = _this.fieldNames;
              oldFormData = _lodash["default"].get(_this, "formProps.state.formData", _this.props.formData);
              if (address) {
                _context.next = 7;
                break;
              }
              newFormData = _extends({}, oldFormData, (_extends2 = {}, _extends2[fieldNames.address_1] = null, _extends2[fieldNames.address_2] = null, _extends2[fieldNames.postal_code] = null, _extends2[fieldNames.state] = null, _extends2[fieldNames.latitude] = null, _extends2[fieldNames.longitude] = null, _extends2));
              _this.formProps && _this.formProps.setState(newFormData);
              _this.formProps && _this.formProps.onChange(newFormData);
              return _context.abrupt("return");
            case 7:
              _context.next = 9;
              return (0, _reactPlacesAutocomplete.geocodeByPlaceId)(address.placeId);
            case 9:
              _yield$geocodeByPlace = _context.sent;
              geocode = _yield$geocodeByPlace[0];
              firstAddress = _this.getFieldByGeoCode(geocode, ["street_number", "route", "neighborhood"]);
              city = _this.getFieldByGeoCode(geocode, "locality");
              state = _this.getFieldByGeoCode(geocode, "administrative_area_level_1");
              country = _this.getFieldByGeoCode(geocode, "country");
              postalCode = _this.getFieldByGeoCode(geocode, "postal_code");
              _this$getFieldLocatio = _this.getFieldLocation(geocode), lat = _this$getFieldLocatio.lat, lng = _this$getFieldLocatio.lng;
              addressData = (_addressData = {}, _addressData[fieldNames.address_1] = firstAddress, _addressData[fieldNames.address_2] = null, _addressData[fieldNames.postal_code] = postalCode, _addressData[fieldNames.state] = state, _addressData[fieldNames.city] = city, _addressData[fieldNames.country] = country, _addressData[fieldNames.latitude] = lat, _addressData[fieldNames.longitude] = lng, _addressData);
              updateAdjacentFields = _lodash["default"].get(_this.props, "uiSchema.ui:options.updateAdjacentFields") || false;
              if (updateAdjacentFields) {
                _this.formProps && _this.formProps.onChange(_extends({}, oldFormData, addressData));
              }
              _this.props.onChange(addressData);
              _this.forceUpdate();
            case 22:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
    _defineProperty(_this, "handleChange", function (value) {
      console.log(value);
      _this.props.onChange && _this.props.onChange(value);
    });
    return _this;
  }
  _inheritsLoose(ReactPlaceAutofillField, _React$Component);
  var _proto = ReactPlaceAutofillField.prototype;
  _proto.getFieldByGeoCode = function getFieldByGeoCode(geocode, placeType) {
    var _this2 = this;
    var addressComponents = geocode.address_components;
    if (_lodash["default"].isArray(placeType)) {
      var placeTerms = _lodash["default"].map(placeType, function (type) {
        return _this2.getAddressComponentByType(addressComponents, type);
      });
      return _lodash["default"].compact(placeTerms).join(", ");
    }
    var selectedComponent = _lodash["default"].find(addressComponents, function (component) {
      return _lodash["default"].includes(component.types, placeType);
    });
    return selectedComponent && selectedComponent.long_name;
  };
  _proto.getAddressComponentByType = function getAddressComponentByType(addressComponents, placeType) {
    var selectedComponent = _lodash["default"].find(addressComponents, function (component) {
      return _lodash["default"].includes(component.types, placeType);
    });
    return selectedComponent && selectedComponent.long_name;
  };
  _proto.getFieldLocation = function getFieldLocation(geocode) {
    var geocodeLocation = geocode.geometry.location;
    var lat = geocodeLocation.lat();
    var lng = geocodeLocation.lng();
    return {
      lat: lat,
      lng: lng
    };
  };
  _proto.render = function render() {
    var showFields = _lodash["default"].get(this.props, "uiSchema.ui:options.showFields", false);
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_ReactPlaceField["default"], {
      schema: this.props.schema,
      uiSchema: this.props.uiSchema,
      onChange: this.handleChange,
      onPlaceSelect: this.handlePlaceSelect
    }), showFields && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card, {
      key: "a"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card.Body, null, this.renderFormFields())));
  };
  _proto.renderFormFields = function renderFormFields() {
    var _this3 = this;
    var propsValue = this.props.formData;
    return _lodash["default"].map(this.fieldNames, function (fieldName, key) {
      return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, {
        className: "p-4",
        key: "form-" + _this3.state.id + "-" + key
      }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Label, null, _lodash["default"].chain(fieldName).split("_").map(_lodash["default"].capitalize).join(" ").value()), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Control, {
        value: propsValue[fieldName] || "",
        onChange: _this3.handleFieldChange(key, fieldName)
      }));
    });
  };
  return _createClass(ReactPlaceAutofillField, [{
    key: "formProps",
    get: function get() {
      return _lodash["default"].get(this.props.formContext, "form.current", null);
    }
  }, {
    key: "fieldNames",
    get: function get() {
      var newValues = _lodash["default"].get(this.props, "uiSchema.ui:options.fields", {});
      return _lodash["default"].merge(DEFAULT_FIELDS, newValues);
    }
  }]);
}(_react["default"].Component);
var _default = exports["default"] = ReactPlaceAutofillField;
module.exports = exports.default;