"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactBootstrap = require("react-bootstrap");
var _lodash = _interopRequireDefault(require("lodash"));
var _us_states = require("../helpers/us_states");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var StatesWidget = function StatesWidget(props) {
  var _$get = _lodash["default"].get(props, "schema", {}),
    title = _$get.title;
  var state_abbreviations = Object.keys(_us_states.us_states);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Label, null, title), /*#__PURE__*/_react["default"].createElement("select", {
    id: props.id,
    className: "form-control",
    value: props.value,
    required: props.required,
    onChange: function onChange(event) {
      return props.onChange(event.target.value);
    },
    disabled: props.disabled,
    readOnly: props.readonly
  }, /*#__PURE__*/_react["default"].createElement("option", {
    value: ""
  }, " "), state_abbreviations.map(function (state) {
    return /*#__PURE__*/_react["default"].createElement("option", {
      key: state,
      value: state
    }, state);
  })));
};
var _default = exports["default"] = StatesWidget;
module.exports = exports.default;