function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React, { Component } from "react";
import ReactDOM from "react-dom";
import Scanner from "./scanner";
import { BrowserMultiFormatReader } from "@zxing/library/esm/browser/BrowserMultiFormatReader.js";
var styles = {
  closeButton: {
    position: "fixed",
    bottom: "0px",
    left: "0px"
  }
};
var ReactScannerField = /*#__PURE__*/function (_Component) {
  function ReactScannerField(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _defineProperty(_this, "handleChange", function (codeValue) {
      console.log(codeValue);
      _this.props.onChange(codeValue);
      _this.setState({
        showScanner: false,
        value: codeValue
      });
    });
    _defineProperty(_this, "handleScannerClose", function () {
      _this.codeReader.stopStreams();
      _this.setState({
        showScanner: false
      });
    });
    _defineProperty(_this, "handleScannerOpen", function () {
      _this.setState({
        showScanner: true
      });
    });
    _this.codeReader = new BrowserMultiFormatReader();
    _this.state = _extends({}, props, {
      showScanner: false,
      value: null
    });
    return _this;
  }
  _inheritsLoose(ReactScannerField, _Component);
  var _proto = ReactScannerField.prototype;
  _proto._getScanner = function _getScanner() {
    return ReactDOM.createPortal(/*#__PURE__*/React.createElement("div", {
      style: {
        position: "fixed",
        top: 0,
        width: "100%",
        height: "100%",
        backgroundColor: "rgba(255, 255, 255, 0.5)"
      }
    }, /*#__PURE__*/React.createElement(Scanner, {
      codeReader: this.codeReader,
      codeType: "datamatrix",
      onCode: this.handleChange
    }), /*#__PURE__*/React.createElement("button", {
      style: styles.closeButton,
      onClick: this.handleScannerClose,
      className: "btn btn-block btn-secondary"
    }, "Close")), document.getElementsByTagName("body")[0]);
  };
  _proto.render = function render() {
    var _this2 = this;
    return /*#__PURE__*/React.createElement("span", null, this.state.showScanner ? this._getScanner() : /*#__PURE__*/React.createElement("span", null, this.state.value && /*#__PURE__*/React.createElement("span", {
      className: "mr-2"
    }, this.state.value), /*#__PURE__*/React.createElement("button", {
      onClick: this.handleScannerOpen,
      className: "btn btn-sm btn-secondary"
    }, "Scan"), this.state.value && /*#__PURE__*/React.createElement("button", {
      onClick: function onClick() {
        var clearValue = confirm("Are you sure?");
        if (clearValue) _this2.setState({
          value: null
        });
      },
      className: "btn btn-sm btn-secondary ml-1"
    }, "\xD7")));
  };
  return ReactScannerField;
}(Component);
export default ReactScannerField;