function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
import React, { Component } from "react";
import _ from "lodash";
import SignatureCanvas from "react-signature-canvas";
var ReactSignatureCanvasField = /*#__PURE__*/function (_Component) {
  function ReactSignatureCanvasField(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _this.state = _extends({}, props, {
      width: props.uiSchema["ui:options"] && props.uiSchema["ui:options"].width || 400,
      height: props.uiSchema["ui:options"] && props.uiSchema["ui:options"].height || 150,
      value: props.formData || ""
    });
    return _this;
  }
  _inheritsLoose(ReactSignatureCanvasField, _Component);
  var _proto = ReactSignatureCanvasField.prototype;
  _proto.componentDidMount = function componentDidMount() {
    if (!this.state.readonly && this.sigCanvas) this.sigCanvas.fromDataURL(this.state.formData);
  };
  _proto._clear = function _clear(e) {
    e.preventDefault();
    var confirmed = confirm("Clear the signature?");
    if (confirmed) {
      this.sigCanvas.clear();
      this.setState({
        value: ""
      });
      this.state.onChange();
    } else {
      return false;
    }
  };
  _proto.render = function render() {
    var _this2 = this;
    return /*#__PURE__*/React.createElement("div", {
      style: {
        position: "relative",
        width: this.state.width + 41,
        minHeight: this.state.height + 40
      }
    }, !this.state.readonly ? /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(SignatureCanvas, {
      ref: function ref(_ref) {
        _this2.sigCanvas = _ref;
      },
      penColor: "black",
      canvasProps: {
        width: this.state.width,
        height: this.state.height,
        className: "sigCanvas",
        style: {
          border: "#ddd 3px dashed",
          borderRadius: 4
        }
      },
      backgroundColor: "#fafafa",
      onEnd: function onEnd(value) {
        _this2.state.onChange(_this2.sigCanvas.toDataURL(value));
        _this2.setState({
          value: _this2.sigCanvas.toDataURL(value)
        });
      }
    }), /*#__PURE__*/React.createElement("input", {
      type: "text",
      style: {
        border: 0,
        height: 1,
        width: 1
      },
      value: this.state.value,
      onChange: function onChange(event) {
        return _this2.state.value;
      },
      readOnly: true,
      required: this.state.required
    }), this.sigCanvas && !this.sigCanvas.isEmpty() ? /*#__PURE__*/React.createElement("button", {
      className: "btn btn-secondary d-print-none",
      style: {
        position: "absolute",
        right: 0,
        top: 0,
        height: this.state.height + 6,
        fontSize: 16,
        fontWeight: "700",
        borderTopLeftRadius: 0,
        borderBottomLeftRadius: 0,
        borderWidth: 3
      },
      onClick: this._clear.bind(this)
    }, "\xD7") : null) : this.state.formData ? /*#__PURE__*/React.createElement("img", {
      style: {
        minHeight: this.state.height
      },
      src: this.state.formData
    }) : /*#__PURE__*/React.createElement("div", {
      style: {
        minHeight: this.state.height,
        fontWeight: "700",
        lineHeight: this.state.height + "px",
        color: "#666",
        backgroundColor: "#fafafa",
        textAlign: "center"
      }
    }, "No Signature"), /*#__PURE__*/React.createElement("div", {
      className: "sigSalutation"
    }, /*#__PURE__*/React.createElement("h6", {
      style: {
        paddingTop: 10,
        marginTop: 15,
        borderTop: "#444 1px solid"
      }
    }, this.state.schema.title)));
  };
  return ReactSignatureCanvasField;
}(Component);
export default ReactSignatureCanvasField;