function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React, { Component } from "react";
import { Form } from "react-bootstrap";
import PropTypes from "prop-types";
import DatePicker from "react-datepicker";
import _ from "lodash";
import "react-datepicker/dist/react-datepicker.css";
import moment from "moment";
var ButtonInput = /*#__PURE__*/function (_React$Component) {
  function ButtonInput() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _defineProperty(_this, "handleClick", function (e) {
      e.preventDefault();
      _this.props.onClick(e);
    });
    return _this;
  }
  _inheritsLoose(ButtonInput, _React$Component);
  var _proto = ButtonInput.prototype;
  _proto.render = function render() {
    var value = this.props.value;
    if (value && this.props.displayFormat) value = moment(this.props.value).format(this.props.displayFormat);
    return /*#__PURE__*/React.createElement("a", {
      className: "btn btn-sm btn-secondary",
      href: "#!",
      onClick: this.handleClick
    }, value || /*#__PURE__*/React.createElement("span", {
      className: "d-print-none"
    }, "Choose Date"));
  };
  return ButtonInput;
}(React.Component);
ButtonInput.propTypes = process.env.NODE_ENV !== "production" ? {
  onClick: PropTypes.func,
  value: PropTypes.string
} : {};
var ReactDatePickerWidget = /*#__PURE__*/function (_Component) {
  function ReactDatePickerWidget(props) {
    var _this2;
    _this2 = _Component.call(this, props) || this;
    _this2.state = _extends({}, props);
    _this2.dataFormat = null;
    _this2.displayFormat = "MM/DD/YYYY";
    if (_this2.state.options && _this2.state.options.format) {
      if (typeof _this2.state.options.format === "object" && _this2.state.options.format !== null) {
        _this2.dataFormat = _this2.state.options.format.data;
        _this2.displayFormat = _this2.state.options.format.display;
      } else {
        _this2.dataFormat = _this2.state.options.format;
        _this2.displayFormat = _this2.state.options.format;
      }
    }
    return _this2;
  }
  _inheritsLoose(ReactDatePickerWidget, _Component);
  var _proto2 = ReactDatePickerWidget.prototype;
  _proto2.render = function render() {
    var _this3 = this;
    var _$get = _.get(this.props, "schema", {}),
      title = _$get.title;
    var selected = null;
    if (this.state.value) selected = moment(this.state.value, this.dataFormat).toDate();
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Form.Label, null, title), /*#__PURE__*/React.createElement("div", {
      style: {
        display: "block"
      }
    }, /*#__PURE__*/React.createElement(DatePicker, {
      customInput: /*#__PURE__*/React.createElement(ButtonInput, {
        displayFormat: this.displayFormat
      }),
      selected: selected,
      required: this.state.required,
      onChange: function onChange(date) {
        var value = date;
        if (_this3.dataFormat) value = moment(date).format(_this3.dataFormat);else value = moment(value).toISOString();
        _this3.setState({
          value: date
        }, function () {
          return _this3.state.onChange(value);
        });
      },
      strictParsing: true,
      disabled: this.state.disabled,
      readOnly: this.state.readonly,
      isClearable: true
    }), /*#__PURE__*/React.createElement("input", {
      name: this.props.id,
      id: this.props.id,
      style: {
        position: "absolute",
        border: 0,
        width: 1,
        height: 1
      },
      type: "text",
      onChange: function onChange(event) {
        return _this3.state.value;
      },
      required: this.props.required,
      value: this.state.value || ""
    })));
  };
  return ReactDatePickerWidget;
}(Component);
export default ReactDatePickerWidget;