"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _lodash = _interopRequireDefault(require("lodash"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var MustacheHelper = /*#__PURE__*/function () {
  function MustacheHelper() {}
  var _proto = MustacheHelper.prototype;
  _proto.getCompiledText = function getCompiledText(rawText, valueMappings) {
    if (valueMappings === void 0) {
      valueMappings = {};
    }
    var compiled = _lodash["default"].template(rawText, {
      interpolate: /{{([\s\S]+?)}}/g
    });
    var compiledText = compiled(valueMappings);
    return compiledText;
  };
  return MustacheHelper;
}();
var _default = exports["default"] = new MustacheHelper();
module.exports = exports.default;