"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactBootstrap = require("react-bootstrap");
var _lodash = _interopRequireDefault(require("lodash"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
var PercentWidget = /*#__PURE__*/function (_Component) {
  function PercentWidget(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _this.state = _extends({}, props, {
      value: props.value && props.value * 100
    });
    return _this;
  }
  _inheritsLoose(PercentWidget, _Component);
  var _proto = PercentWidget.prototype;
  _proto._handleChange = function _handleChange(event) {
    var digits = this.state.options.digits == undefined ? 2 : this.state.options.digits;
    var value = event.target.value.replace(/[^0-9.]/g, "");
    if (event.type === "blur" && event.target.value) value = parseFloat(value).toFixed(digits);
    this.setState({
      value: value
    });
    this.state.onChange(value / 100);
  };
  _proto.render = function render() {
    var _this2 = this;
    var _$get = _lodash["default"].get(this.props, "schema", {}),
      title = _$get.title;
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Label, null, title), /*#__PURE__*/_react["default"].createElement("div", {
      className: "input-group"
    }, /*#__PURE__*/_react["default"].createElement("input", {
      type: "text",
      id: this.props.id,
      className: "form-control percent",
      style: {
        textAlign: "right"
      },
      value: this.state.value,
      required: this.state.required,
      onBlur: function onBlur(event) {
        _this2._handleChange(event);
      },
      onChange: function onChange(event) {
        _this2._handleChange(event);
      },
      disabled: this.state.disabled,
      readOnly: this.state.readonly
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "input-group-append"
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: "input-group-text"
    }, "%"))));
  };
  return PercentWidget;
}(_react.Component);
var _default = exports["default"] = PercentWidget;
module.exports = exports.default;