"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _lodash = _interopRequireDefault(require("lodash"));
var _reactBootstrap = require("react-bootstrap");
var _button = _interopRequireDefault(require("./button"));
var _checkbox = _interopRequireDefault(require("./checkbox"));
var _radio = _interopRequireDefault(require("./radio"));
var _constants = require("./constants");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var ReactInputTableWidget = /*#__PURE__*/function (_React$Component) {
  function ReactInputTableWidget() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _defineProperty(_this, "state", {
      checkbox: true
    });
    return _this;
  }
  _inheritsLoose(ReactInputTableWidget, _React$Component);
  var _proto = ReactInputTableWidget.prototype;
  _proto.renderFooterItems = function renderFooterItems() {
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, {
      className: "align-items-center justify-content-md-end"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
      sm: "auto"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
      variant: "link",
      size: "sm"
    }, "Add Row"), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
      variant: "link",
      size: "sm"
    }, "Add Column")));
  };
  _proto.renderTable = function renderTable() {
    var _$get = _lodash["default"].get(this.props, "uiSchema.ui:options", {}),
      inputTableType = _$get.inputTableType;
    switch (inputTableType) {
      case _constants.CHECKBOX:
        return /*#__PURE__*/_react["default"].createElement(_checkbox["default"], this.props);
      case _constants.RADIO:
        return /*#__PURE__*/_react["default"].createElement(_radio["default"], this.props);
      default:
        return /*#__PURE__*/_react["default"].createElement(_button["default"], this.props);
    }
  };
  _proto.render = function render() {
    var _$get2 = _lodash["default"].get(this.props, "schema", {}),
      title = _$get2.title;
    var _$get3 = _lodash["default"].get(this.props, "uiSchema.ui:options", {}),
      headerModifiable = _$get3.headerModifiable,
      columnModifiable = _$get3.columnModifiable;
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Label, null, title), this.renderTable(), headerModifiable && columnModifiable && this.renderFooterItems());
  };
  return ReactInputTableWidget;
}(_react["default"].Component);
var _default = exports["default"] = ReactInputTableWidget;
module.exports = exports.default;