"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactBootstrap = require("react-bootstrap");
var _reactFontawesome = _interopRequireDefault(require("react-fontawesome"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var FileDisplay = /*#__PURE__*/function (_React$Component) {
  function FileDisplay() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _defineProperty(_this, "handleRemove", function (file, index) {
      var onRemove = _this.props.onRemove;
      onRemove && onRemove(file, index);
    });
    return _this;
  }
  _inheritsLoose(FileDisplay, _React$Component);
  var _proto = FileDisplay.prototype;
  _proto.render = function render() {
    var _this2 = this;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "file-display mx-2 my-3"
    }, (this.props.files || []).map(function (file, index) {
      return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, {
        key: index,
        className: "file"
      }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null, file.url ? /*#__PURE__*/_react["default"].createElement("a", {
        target: "_blank",
        href: "" + file.url
      }, file.name || file.file_name) : file.name || file.file_name), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
        xs: "auto"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        onClick: function onClick() {
          return _this2.handleRemove(file, index);
        },
        className: "btn btn-sm p-0 d-print-none"
      }, /*#__PURE__*/_react["default"].createElement(_reactFontawesome["default"], {
        name: "trash-alt"
      }))));
    }));
  };
  return FileDisplay;
}(_react["default"].Component);
var _default = exports["default"] = FileDisplay;
module.exports = exports.default;